package com.hrsk.cloud.eg.infrastructure.repository.database.entity;

import com.hrsk.cloud.eg.domain.common.utils.PrivacyAesUtil;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 信贷订单表
 * </p>
 *
 * @author
 * @since 2019-09-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class XdOrderInfo implements Serializable {

    //@TableId(value = "id", type = IdType.AUTO)
    private Long id;

    //申请id
    private Integer applyId;

    private Long userId;


    //产品id
    private Integer productId;

    //抢单状态 -2.无匹配 -1.待推送 0.待抢单(初始状态) " +
    //            "1.已抢单 2.被拒绝(系统策略拒绝,或后台初审拒绝) 3.订单关闭(长时间无人抢单,订单被关闭) 4.被退单 5.订单完成(已结算)6.超时关闭（超过5天未处理,平台方关闭该订单）
    private Integer status;

    //订单状态  0-申请成功 2-申请失败 3退单 4取消订单
    private Integer oStatus;

    //抢单方式 1.独享 2.共享 3.未知
    private Integer orderType;

    private Date createTime;

    private String createBy;

    private Date updateTime;


    private String updateBy;

    private String submitTime;

    private String reason;

    /*
        borrow_money,
        borrow_limit,
        borrow_purpose,
        is_grab,
        is_apply,
        user_mobile,
        real_name,
        channel_name,
        product_name
        借款金额 单位万元，1-100之间的整数。
     */
    private Integer borrowMoney;

    //借款金额
    private Integer borrowRange;

    //借款期限 1. 1个月 2. 3个月 3. 6个月 4. 9个月 5. 12个月 6. 24个月 7. 36个月 8. 36个月以上
    private Integer borrowLimit;

    //借款用途 1.购车贷款 2.购房贷款 3.装修贷款 4.教育贷款 5.消费贷款 6.过桥贷款 7.结婚贷款 8.旅游贷款 9.医疗贷款 10.其他贷款
    private Integer borrowPurpose;


    //用户电话
    private String userMobile;

    //用户真实姓名
    private String realName;

    //推广渠道名
    private String channelName;

    //推广渠道
    private String channelCode;

    //信贷产品名
    private String productName;

    //商务后台状态: 0:待处理,1:待跟进,2:有效用户,3:无效用户
    private Integer merchantStatus;

    //商务后台备注
    private String merchantRemark;


    //投放渠道
    private Integer deliveryMethod;


    //单价
    private BigDecimal price;

    //对接的crm平台
    private String crmPlatform;

    //车产
    private Integer carType;

    //房产
    private Integer houseType;

    //寿险
    private Integer insuranceType;

    //公积金
    private Integer accumulation;

    //社保
    private Integer socialSecurity;

    //信用卡
    private Integer creditCard;

    //芝麻分
    private Integer sesame;

    //城市
    private String city;

    //职业
    private Integer profession;

    //车产估值
    private Integer carAppraisement;
    //房产估值
    private Integer houseAppraisement;
     //保单保价
    private Integer insuranceAppraisement;
    //车辆是否抵押
    private Integer carImpawn;

    //房子是否抵押
    private Integer houseImpawn;

    //机构id
    private String busiId;
    //机构id
    private String mainAccount;

    //月收入code
    private Integer monthlyIncomeCode;

   //表单id
    private Integer formId;

    //交易流水号
    private String tradeNo;


    private String userSex;

   // 是否逾期 0:无逾期 1:逾期一月内 2 逾期三个月内 3逾期超过三个月
    private Integer overdue;

    //订单失败原因
    private String applyFailReason;


    private String userMobileSalt;

    private String ip;

    //商户查看状态,1-已查看，其他-未查看
    private Integer viewStatus;

    private String userMobileMd5;

    /** 归因渠道编号 */
    private String ascriptionChannelCode;

    public void encAll(){
        Map<String,String> mobileMap = PrivacyAesUtil.encryptNum(this.userMobile);
        this.userMobile = mobileMap.get(PrivacyAesUtil.RESULT);
        this.userMobileSalt = mobileMap.get(PrivacyAesUtil.SALT);
    }
    public void decAll(){
        this.userMobile = PrivacyAesUtil.decryptNum(this.userMobile, this.userMobileSalt);
    }

}
